﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using Kupo.Helpers;
using TreeSharp;
using Action = TreeSharp.Action;

namespace Kupo.Rotations
{
    public class DarkKnight : KupoRoutine
    {
        //DEVELOPERS REPLACE GetType().Name WITH YOUR CR'S NAME.
        public override string Name
        {
            get { return "Kupo [" + GetType().Name + "]"; }
        }

        public override float PullRange
        {
            get { return 2.5f; }
        }

        public override ClassJobType[] Class
        {
            get { return new[] { ClassJobType.DarkKnight }; }
        }

        [Behavior(BehaviorType.PreCombatBuffs)]
        public Composite CreateBasicPreCombatBuffs()
        {
            return SummonChocobo();
        }

        [Behavior(BehaviorType.Rest)]
        public Composite CreateBasicRest()
        {
            return DefaultRestBehavior(r => Core.Player.CurrentTPPercent);
        }

        [Behavior(BehaviorType.Pull)]
        public Composite CreateBasicPull()
        {
                        return new PrioritySelector(ctx => Core.Player.CurrentTarget as BattleCharacter,
                new Decorator(ctx => ctx != null,new PrioritySelector(
                        CommonBehaviors.MoveToLos(ctx => ctx as GameObject),
                        CommonBehaviors.MoveAndStop(ctx => (ctx as GameObject).Location, ctx => Core.Player.CombatReach + PullRange + (ctx as GameObject).CombatReach, true, "Moving to unit"),
                Spell.PullCast("Unmend")
                )));
        }
		
        [Behavior(BehaviorType.Combat)]
        public Composite CreateBasicCombat()
        {
            return new PrioritySelector(ctx => Core.Player.CurrentTarget as BattleCharacter,
                new Decorator(ctx => ctx != null,
                    new PrioritySelector(
                        CommonBehaviors.MoveToLos(ctx => ctx as GameObject),
                        CommonBehaviors.MoveAndStop(ctx => (ctx as GameObject).Location, ctx => Core.Player.CombatReach + PullRange + (ctx as GameObject).CombatReach, true, "Moving to unit"),
                        //Darkside activation and MP Control to keep it up as long as possible
                        Spell.Apply("Darkside", r => Core.Player.CurrentManaPercent >= 85, r => Core.Player),						
						Spell.Cast("Blood Weapon", r => Core.Player.CurrentManaPercent <= 75, r => Core.Player),
						Spell.Cast("Blood Price", r => Core.Player.CurrentManaPercent <= 50, r => Core.Player),
						//Check health and see if we need to reduce the dmg for 20 secs
						Spell.Cast("Shadowskin", r => Core.Player.CurrentHealthPercent <= 70, r => Core.Player),
						//Basic Combat Combo Routine
						Spell.Cast("Spinning Slash", r => Actionmanager.LastSpell.Name == "Hard Slash"),
                        Spell.Cast("Power Slash", r => Actionmanager.LastSpell.Name == "Spinning Slash"),
                        Spell.Cast("Hard Slash", r => true)
                        )));
        }
    }
}